using System;
using System.Drawing;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Globalization;

namespace DynamicRowAndCol_SectionReport
{
    /// <summary>
    /// Summary description for SectionReport1.
    /// </summary>
    public partial class SectionReport1 : GrapeCity.ActiveReports.SectionReport
    {

        public SectionReport1()
        {
            //
            // Required for Windows Form Designer support
            //
            InitializeComponent();
        }

        private int rowcount = 0;
        private DataTable dt;

        // ǰԴ
        public DataTable UnboundDataSource
        {
            get { return dt; }
            set { dt = value; }
        }        

        private void SectionReport1_DataInitialize(object sender, EventArgs e)
        {
            foreach (DataColumn col in dt.Columns)
            {
                this.Fields.Add(col.ColumnName);
            }
        }

        private void SectionReport1_ReportStart(object sender, EventArgs e)
        {
            // ԴֽŴС
            this.PageSettings.Margins = new GrapeCity.ActiveReports.Document.Section.Margins(0.5f, 0.5f, 0.5f, 0.5f);
            this.PageSettings.DefaultPaperSize = false;
            this.PageSettings.PaperHeight = 12F;
            this.PageSettings.PaperKind = System.Drawing.Printing.PaperKind.Custom;
            this.PageSettings.PaperName = "Զֽ";
            this.PageSettings.PaperWidth = dt.Columns.Count + 1.5f;

            this.PrintWidth = this.PageSettings.PaperWidth - 1f;

            // ӱͷϢ
            GrapeCity.ActiveReports.SectionReportModel.Label lrow = new GrapeCity.ActiveReports.SectionReportModel.Label();
            lrow.Name = "Header_Row";
            lrow.Width = 0.5f;
            lrow.Location = new PointF(0, 0);
            lrow.Text = "к";
            lrow.Border.BottomStyle = GrapeCity.ActiveReports.BorderLineStyle.ThickSolid;
            pageHeader.Controls.Add(lrow);

            GrapeCity.ActiveReports.SectionReportModel.TextBox trow = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
            trow.Name = "Detail_Row";
            trow.Width = 0.5f;
            trow.Location = new PointF(0, 0);            
            trow.Border.BottomStyle = GrapeCity.ActiveReports.BorderLineStyle.Solid;
            trow.BackColor = Color.Teal;
            trow.Alignment = GrapeCity.ActiveReports.Document.Section.TextAlignment.Center;
            detail.Controls.Add(trow);

            for (int i = 0; i < dt.Columns.Count; i++)
            {
                // ӱͷϢ
                GrapeCity.ActiveReports.SectionReportModel.Label label = new GrapeCity.ActiveReports.SectionReportModel.Label();
                label.Name = string.Format("Header_{0}", i);
                label.Width = 1;
                label.Location = new PointF(i+0.5f, 0);
                label.Text = dt.Columns[i].Caption;
                label.Border.BottomStyle = GrapeCity.ActiveReports.BorderLineStyle.ThickSolid;
                pageHeader.Controls.Add(label);

                // ϸϢ
                GrapeCity.ActiveReports.SectionReportModel.TextBox textBox = new GrapeCity.ActiveReports.SectionReportModel.TextBox();
                textBox.Name = string.Format("Detail_{0}", i);
                textBox.Width = 1;
                textBox.Location = new PointF(i+0.5f, 0);
                textBox.DataField = dt.Columns[i].Caption;
                textBox.Border.BottomStyle = GrapeCity.ActiveReports.BorderLineStyle.Solid;
                detail.Controls.Add(textBox);
            }
        }

        private void SectionReport1_FetchData(object sender, FetchEventArgs eArgs)
        {
            if (rowcount == dt.Rows.Count)
            {
                // һ EOF Ϊ true
                eArgs.EOF = true;
                return;
            }
            else
            {
                // Ϊֵֶ
                for (int i = 0; i < dt.Columns.Count; i++)
                {
                    this.Fields[dt.Columns[i].ColumnName].Value = dt.Rows[rowcount][i];
                }
                
                // к
                eArgs.EOF = false;
                rowcount++;

                // к
                (this.detail.Controls["Detail_Row"] as GrapeCity.ActiveReports.SectionReportModel.TextBox).Value = rowcount;
            }
        }

        private void detail_Format(object sender, EventArgs e)
        {
            // жDetailпؼֵǷһһֻʾһؼؼ
        }
    }
}
